﻿namespace CodeContractsDemo
{
    using System;
    using System.Diagnostics.Contracts;

    [ContractClass(typeof(PersonContract))]
    public interface IPerson
    {
        string Name { get; set; }
        int Age { get; set; }

        void ShowInfo();
    }

    [ContractClassFor(typeof(IPerson))]
    public abstract class PersonContract : IPerson
    {
        public abstract string Name { get; set; }
        public abstract int Age { get; set; }

        public void ShowInfo()
        {
            Contract.Requires(!string.IsNullOrEmpty(this.Name));
            Contract.Requires(this.Age > 5);
        }
    }

    public class Person : IPerson
    {

        #region IPerson Members

        public string Name { get; set; }

        public int Age { get; set; }

        public void ShowInfo()
        {
            Console.WriteLine("Name: {0}", this.Name);
            Console.WriteLine("Age: {0}", this.Age);
        }

        #endregion
    }
}