﻿namespace CodeContractsDemo
{
    using System;
    using System.Diagnostics.Contracts;

    class Program
    {
        static void Main(string[] args)
        {
            Contract.ContractFailed += 
                new EventHandler<ContractFailedEventArgs>(Contract_ContractFailed); 

            var paymentProcessor = new PaymentProcessor();

            paymentProcessor.Add(new Payment() {
                Amount = 100.0,
                Name = "Axel",
                Date = DateTime.Now
            });

            paymentProcessor.Add(new Payment() {
                Amount = 150.0,
                Name = "Max",
                Date = DateTime.Now
            });

            paymentProcessor.Add(new Payment() {
                Amount = 20.0,
                Name = "Axel",
                Date = DateTime.Now
            });

            var alexsPayments = paymentProcessor.GetPaymentsTotal("Axel");
            Console.WriteLine("Alex's payments = {0}", alexsPayments);

            var point = new Point(10, 10);
            point.X = 20;
            point.Set(-30, 10);
            point.Test(1, 2);

            var person = new Person();
            // person.ShowInfo();

            Console.WriteLine("Press any key");
            Console.ReadKey(true);
        }

        static void Contract_ContractFailed(object sender, ContractFailedEventArgs e)
        {
            Console.WriteLine(e.Message);
            //e.SetUnwind();
            e.SetHandled();
        }
    }
}